/* Zaklady programovani v C++
   Okomentovane priklady ze cviceni 7A ... znaky, switch, generovani pseudonahodnych cisel
*/

#include<iostream>
using namespace std;
#include<cctype>
#include<ctime>


/* SWITCH bez prikazu break a bez vetve default */
void vypis0(int a)
{
	switch (a)
	{
	case 1:
		cout << "jedna ";
	case 3:
		cout << "tri ";
	case 2:
		cout << "dva ";
	}
	cout << '\n';
}


/* SWITCH s vetvi "default" a s prikazy break  */
void vypis1(int a)
{
	switch (a)
	{
	case 1:
		cout << "jedna ";
		break;
	case 3:
		cout << "tri ";
		break;
	case 2:
		cout << "dva ";
		break;
	default:
		cout << "neco jineho ";
		break;
	}
	cout << '\n';
}


/* SWITCH s vetvi "default" a s prikazy break ... slozitejsi  */
void vypis(int a)
{
	switch (a)
	{
	case 1:
		cout << "jedna ";
		break;
	case 2:
		cout << "dva ";
		break;
	case 5:
		cout << "pet nebo ";
	case 6:
		cout << "sest";
		break;
	case 3:
	case 4:
		cout << "tri nebo ctyri ";
		break;

	default:
		cout << "neco jineho ";
		break;
	}
	cout << endl;
}

int objemy0()
{
	const double pi = 3.14;
	double V, S;

	cout << "Kalkulacka" << endl;
	cout << "pro objem a povrch koule zadej k" << endl;
	cout << "pro objem a povrch jehlanu zadej j" << endl;
	cout << "pro objem a povrch valce zadej v" << endl;
	cout << "pro konec zadej z" << endl;

	char znak;
	cin >> znak;

	// ukazka switch 
	switch (znak)
	{
	case 'k':
		break;
	}

	if (znak == 'k')
	{
		cout << "****** Objem a povrch koule ******" << endl;
		double r;
		cout << "Zadej polomer koule: ";
		cin >> r;
		V = 4.0 / 3 * pi * pow(r, 3);
		S = 4 * pi * r * r;
		cout << "objem koule je " << V << ", jeji povrch je " << S << endl;
	}
	else if (znak == 'v')
	{
		cout << "****** Objem a povrch valce ******" << endl;
		double r, v;
		cout << "Zadej polomer podstavy valce: ";
		cin >> r;
		cout << "Zadej vysku valce: ";
		cin >> v;
		V = pi * pow(r, 2) * v;
		S = 2 * pi * r * (r + v);
		cout << "objem jehlanu je " << V << ", jeho povrch je " << S << endl;
	}
	else if (znak == 'j')
	{
		cout << "****** Objem a povrch jehlanu ******" << endl;
		double a, v;
		cout << "Zadej delku strany podstavy jehlanu: ";
		cin >> a;
		cout << "Zadej vysku jehlanu: ";
		cin >> v;
		V = 1.0 / 3 * v * pow(a, 2);
		S = a * (a + sqrt(4 * pow(v, 2) + pow(a, 2)));
		cout << "objem jehlanu je " << V << ", jeho povrch je " << S << endl;
	}

	return 0;
}

void myslimsi()
{
	cout << "myslim si cislo od 1 do 100.Uhodni ktere.\n";
	int cislo = rand() % 100+1, hadane;
	do {
		cout << "zadej cislo od 1 do 100:";
		cin >> hadane;
		if (!cin)
		{
			cin.clear();
			cin.ignore(256, '\n');
			continue;
		}
		if (hadane > cislo)
		{
			cout << "zkus mensi cislo. ";
		}
		else if (hadane < cislo)
		{
			cout << "zkus vetsi cislo. ";
		}

	} while (cislo != hadane);
	cout << "Trefa\n";

}

int main()
{
	// datovy typ char
	{
		// deklarace promenne a jeji inicializace
		char a = 'a';
		char b = 97;       // kod znaku v ASCII tabulce (dekadicky)
		char c = '\x61';   // kod znaku v ASCII tabulce (hexadecimalne)
		char d = '\141';   // kod znaku v ASCII tabulce (oktalove)
		
		// operace nad znaky
		a = a + 3;
		if (b > a)
			;
		if (b < 'z')
			;
		if (b > 123)
			;
		a = ' ';
		a = '\t';
		a = '\'';
		
		// vypis znaku na konzoli:
		cout << a << b << c << d << '\n';
		putchar(a);

		cout << "Zadej aspon 6 znaku (prokladanych mezerami): ";
		// nacitani znaku z konzole vcetne bilych znaku:
		a = getchar();
		b = getchar();
		c = getchar();

		cout << a << b << c  << '\n';

		// nacitani znaku z konzole bez bilych znaku:
		cin >> a;
		cin >> b;
		cin >> c;

		cout << a << b << c << '\n';

		// pouziti funkci z knihovny cctype: 
		// cin >> a;
		if (isalpha(a))
			cout << a <<  " je pismeno\n";
		else 
			cout << a << " neni pismeno\n";

		// pretypovani na int, vypis ASCII kodu znaku:
		int x = a;
		cout << a << ' ' << x << (int)a << '\n';

	}

	// ukazky na switch:
	for (int i = 0; i < 5; i++)
	{
		cout << i << ": ";
		vypis0(i);
	}

	for (int i = 0; i < 5; i++)
	{
		cout << i << ": ";
		vypis1(i);
	}

	for (int i = 0; i <= 8; i++)
	{
		cout << i << ": ";
		vypis(i);
	}

	objemy0();

	// ukazky generovani pseudonahodnych cisel:
	{
		// srand(15554);      // pevne dany pocatecni 'seed' generatoru
		srand(time(NULL)); // pokazde jiny 'seed' generatoru

		int cislo = rand() % 10;
		cout << cislo << endl;

		myslimsi();
	}
	
	return 0;
}